/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.17 Revision 1.90
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.17 2008/11/21 17:06:03 jmbsvicetto Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.90 2011/04/22 18:48:03 abcd Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# and use deps from EAPI="2", hence you must define EAPI="2" in the ebuild, 14# over time as new EAPI versions are approved.
15# before inheriting any eclasses.
16 15
17inherit base cmake-utils eutils kde4-functions multilib 16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual}
18 22
19case "${EAPI}" in 23inherit kde4-functions fdo-mime gnome2-utils base virtualx versionator eutils
20 2)
21 EXPORT_FUNCTIONS pkg_setup src_unpack src_configure src_compile src_test src_install pkg_postinst pkg_postrm
22 ;;
23 *)
24 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm
25 ;;
26esac
27 24
28# Set the qt dependencies 25if [[ ${BUILD_TYPE} = live ]]; then
29kde4-base_set_qt_dependencies() { 26 case ${KDE_SCM} in
30 local qt qtcore qtgui qt3support qtdepend qtopengldepend 27 svn) inherit subversion ;;
31 28 git) inherit git ;;
32 # use dependencies
33 case "${EAPI}" in
34 2 | 2_pre3 | 2_pre2 | 2_pre1)
35
36 qt="["
37 case "${OPENGL_REQUIRED}" in
38 always)
39 qt="${qt}opengl,"
40 ;;
41 optional)
42 qt="${qt}opengl?,"
43 ;;
44 esac
45 qt="${qt}accessibility,dbus,gif,jpeg,png,qt3support,ssl,zlib]"
46 qtcore="[qt3support,ssl]"
47 qtgui="[accessibility,dbus]"
48 qt3support="[accessibility]"
49 ;;
50 esac 29 esac
30fi
51 31
52 # split qt 32# @ECLASS-VARIABLE: CMAKE_REQUIRED
53 qtdepend=" 33# @DESCRIPTION:
54 !x11-libs/qt-phonon 34# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
55 x11-libs/qt-core:4${qtcore} 35# Please note that if it's set to 'never' you need to explicitly override following phases:
56 x11-libs/qt-gui:4${qtgui} 36# src_configure, src_compile, src_test and src_install.
57 x11-libs/qt-qt3support:4${qt3support} 37# Defaults to 'always'.
58 x11-libs/qt-script:4 38: ${CMAKE_REQUIRED:=always}
59 x11-libs/qt-svg:4 39if [[ ${CMAKE_REQUIRED} = always ]]; then
60 x11-libs/qt-test:4" 40 buildsystem_eclass="cmake-utils"
61 qtopengldepend="x11-libs/qt-opengl:4" 41 export_fns="src_configure src_compile src_test src_install"
42fi
62 43
63 # allow monolithic qt for PV < 4.1 44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63
64# Set slot for KDEBASE known packages
65case ${KDEBASE} in
66 kde-base)
67 SLOT=$(_calculate_kde_slot)
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}"
69 KDE_MINIMAL="${SLOT}"
70 ;;
71 koffice)
72 SLOT="2"
73 ;;
74 kdevelop)
75 if [[ ${BUILD_TYPE} = live ]]; then
76 # @ECLASS-VARIABLE: KDEVELOP_VERSION
77 # @DESCRIPTION:
78 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only.
80 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
81 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
82 # @DESCRIPTION:
83 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
84 # Applies to KDEBASE=kdevelop only.
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
86 else
64 case "${PV}" in 87 case ${PN} in
65 scm|9999*|4.1*|4.0.9*|4.0.8*) : ;; 88 kdevelop|quanta)
89 KDEVELOP_VERSION=${PV}
90 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
91 ;;
92 kdevplatform)
93 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
94 KDEVPLATFORM_VERSION=${PV}
95 ;;
66 *) 96 *)
67 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )" 97 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
68 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )" 98 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
99 esac
100 fi
101 SLOT="4"
69 ;; 102 ;;
70 esac 103esac
71 104
72 # opengl dependencies 105inherit ${buildsystem_eclass}
73 case "${OPENGL_REQUIRED}" in
74 always)
75 qtdepend="${qtdepend}
76 ${qtopengldepend}"
77 ;;
78 optional)
79 IUSE="${IUSE} opengl"
80 qtdepend="${qtdepend}
81 opengl? ( ${qtopengldepend} )"
82 ;;
83 *)
84 OPENGL_REQUIRED="never"
85 ;;
86 esac
87 106
88 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 107EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
89}
90kde4-base_set_qt_dependencies
91 108
92# Set the cmake dependencies 109unset buildsystem_eclass
93case "${PV}" in 110unset export_fns
94 9999*)
95 CMAKEDEPEND=">=dev-util/cmake-2.6"
96 ;;
97 *)
98 CMAKEDEPEND=">=dev-util/cmake-2.4.7-r1"
99 ;;
100esac
101 111
102# Set the common dependencies 112# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
103DEPEND="${DEPEND} ${COMMONDEPEND} ${CMAKEDEPEND} 113# @DESCRIPTION:
104 dev-util/pkgconfig 114# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
105 kde-base/automoc 115# This variable must be set before inheriting any eclasses. Defaults to 'never'.
106 x11-libs/libXt 116DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
107 x11-proto/xf86vidmodeproto"
108RDEPEND="${RDEPEND} ${COMMONDEPEND}"
109 117
110# Add the kdeprefix use flag 118# @ECLASS-VARIABLE: QTHELP_REQUIRED
111case "${EAPI}" in 119# @DESCRIPTION:
112 2 | 2_pre3 | 2_pre2 | 2_pre1) 120# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
113 IUSE="${IUSE} kdeprefix" 121# This variable must be set before inheriting any eclasses. Defaults to 'never'.
114 ;; 122QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
115esac
116 123
117# @ECLASS-VARIABLE: OPENGL_REQUIRED 124# @ECLASS-VARIABLE: OPENGL_REQUIRED
118# @DESCRIPTION: 125# @DESCRIPTION:
119# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 126# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
120# This variable must be set before inheriting any eclasses. Defaults to 'never'. 127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
121OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 128OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
122 129
130# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
131# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135
136# @ECLASS-VARIABLE: WEBKIT_REQUIRED
137# @DESCRIPTION:
138# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'never'.
140WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
141
123# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 142# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
124# @DESCRIPTION: 143# @DESCRIPTION:
125# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 144# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
126# This variable must be set before inheriting any eclasses. Defaults to 'never'. 145# This variable must be set before inheriting any eclasses. Defaults to 'never'.
127CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 146CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
128 147
129case "${CPPUNIT_REQUIRED}" in 148# @ECLASS-VARIABLE: KDE_REQUIRED
149# @DESCRIPTION:
150# Is kde required? Possible values are 'always', 'optional' and 'never'.
151# This variable must be set before inheriting any eclasses. Defaults to 'always'
152# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
153# Note that for kde-base packages this variable is fixed to 'always'.
154KDE_REQUIRED="${KDE_REQUIRED:-always}"
155
156# @ECLASS-VARIABLE: KDE_HANDBOOK
157# @DESCRIPTION:
158# Set to enable handbook in application. Possible values are 'always', 'optional'
159# (handbook USE flag) and 'never'.
160# This variable must be set before inheriting any eclasses. Defaults to 'never'.
161# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
162# ensures buildtime and runtime dependencies.
163KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
164
165# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
166# @DESCRIPTION:
167# Set this varible if you want your live package to manage its
168# translations. (Mostly all kde ebuilds does not ship documentation
169# and translations in live ebuilds)
170if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
171 # Kdebase actualy provides the handbooks even for live stuff
172 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
173 KDE_LINGUAS=""
174fi
175
176# Setup packages inheriting this eclass
177case ${KDEBASE} in
178 kde-base)
179 HOMEPAGE="http://www.kde.org/"
180 LICENSE="GPL-2"
181 if [[ $BUILD_TYPE = live ]]; then
182 # Disable tests for live ebuilds
183 RESTRICT+=" test"
184 # Live ebuilds in kde-base default to kdeprefix by default
185 IUSE+=" +kdeprefix"
186 else
187 # All other ebuild types default to -kdeprefix as before
188 IUSE+=" kdeprefix"
189 fi
190 # This code is to prevent portage from searching GENTOO_MIRRORS for
191 # packages that will never be mirrored. (As they only will ever be in
192 # the overlay).
193 case ${PV} in
194 *9999* | 4.?.[6-9]?)
195 RESTRICT+=" mirror"
196 ;;
197 esac
198 # Block installation of other SLOTS unless kdeprefix
199 RDEPEND+=" $(block_other_slots)"
200 ;;
201 koffice)
202 HOMEPAGE="http://www.koffice.org/"
203 LICENSE="GPL-2"
204 ;;
205 kdevelop)
206 HOMEPAGE="http://www.kdevelop.org/"
207 LICENSE="GPL-2"
208 ;;
209esac
210
211# @ECLASS-VARIABLE: QT_MINIMAL
212# @DESCRIPTION:
213# Determine version of qt we enforce as minimal for the package.
214if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
215 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
216else
217 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
218fi
219
220# Declarative dependencies
221qtdeclarativedepend="
222 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
223"
224case ${DECLARATIVE_REQUIRED} in
130 always) 225 always)
131 DEPEND="${DEPEND} dev-util/cppunit" 226 COMMONDEPEND+=" ${qtdeclarativedepend}"
132 ;; 227 ;;
133 optional) 228 optional)
134 IUSE="${IUSE} test" 229 IUSE+=" declarative"
135 DEPEND="${DEPEND} 230 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
136 test? ( dev-util/cppunit )"
137 ;; 231 ;;
138 *) 232 *) ;;
139 CPPUNIT_REQUIRED="never" 233esac
234unset qtdeclarativedepend
235
236# QtHelp dependencies
237qthelpdepend="
238 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
239"
240case ${QTHELP_REQUIRED} in
241 always)
242 COMMONDEPEND+=" ${qthelpdepend}"
140 ;; 243 ;;
244 optional)
245 IUSE+=" qthelp"
246 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
247 ;;
141esac 248esac
249unset qthelpdepend
142 250
143# @ECLASS-VARIABLE: NEED_KDE 251# OpenGL dependencies
252qtopengldepend="
253 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
254"
255case ${OPENGL_REQUIRED} in
256 always)
257 COMMONDEPEND+=" ${qtopengldepend}"
258 ;;
259 optional)
260 IUSE+=" opengl"
261 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
262 ;;
263 *) ;;
264esac
265unset qtopengldepend
266
267# MultiMedia dependencies
268qtmultimediadepend="
269 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
270"
271case ${MULTIMEDIA_REQUIRED} in
272 always)
273 COMMONDEPEND+=" ${qtmultimediadepend}"
274 ;;
275 optional)
276 IUSE+=" multimedia"
277 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
278 ;;
279 *) ;;
280esac
281unset qtmultimediadepend
282
283# WebKit dependencies
284case ${KDE_REQUIRED} in
285 always)
286 qtwebkitusedeps="[kde]"
287 ;;
288 optional)
289 qtwebkitusedeps="[kde?]"
290 ;;
291 *) ;;
292esac
293qtwebkitdepend="
294 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
295"
296unset qtwebkitusedeps
297case ${WEBKIT_REQUIRED} in
298 always)
299 COMMONDEPEND+=" ${qtwebkitdepend}"
300 ;;
301 optional)
302 IUSE+=" webkit"
303 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
304 ;;
305 *) ;;
306esac
307unset qtwebkitdepend
308
309# CppUnit dependencies
310cppuintdepend="
311 dev-util/cppunit
312"
313case ${CPPUNIT_REQUIRED} in
314 always)
315 DEPEND+=" ${cppuintdepend}"
316 ;;
317 optional)
318 IUSE+=" test"
319 DEPEND+=" test? ( ${cppuintdepend} )"
320 ;;
321 *) ;;
322esac
323unset cppuintdepend
324
325# KDE dependencies
326# Qt accessibility classes are needed in various places, bug 325461
327kdecommondepend="
328 dev-lang/perl
329 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
330 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
331 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
332 >=x11-libs/qt-script-${QT_MINIMAL}:4
333 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
334 >=x11-libs/qt-svg-${QT_MINIMAL}:4
335 >=x11-libs/qt-test-${QT_MINIMAL}:4
336 !aqua? (
337 x11-libs/libXext
338 x11-libs/libXt
339 x11-libs/libXxf86vm
340 )
341"
342
343if [[ ${PN} != kdelibs ]]; then
344 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
345 if [[ ${KDEBASE} = kdevelop ]]; then
346 if [[ ${PN} != kdevplatform ]]; then
347 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
144# @DESCRIPTION: 348 # @DESCRIPTION:
145# This variable sets the version of KDE4 which will be used by the eclass. 349 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
146# This variable must be set by the ebuild, for all categories except for "kde-base". 350 # Applies to KDEBASE=kdevelop only.
147# For kde-base packages, if it is not set by the ebuild, 351 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
148# it's assumed that the required KDE4 version is the latest, non-live, available. 352 case ${KDEVPLATFORM_REQUIRED} in
149# 353 always)
150# @CODE 354 kdecommondepend+="
151# Acceptable values are: 355 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
152# - latest - Use latest version in the portage tree 356 "
153# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice. 357 ;;
154# - svn - Use svn release (live ebuilds)
155# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
156# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
157# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
158# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
159# @CODE
160#
161# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
162# koffice, so you must set it explicitly in the ebuild, in all other cases.
163if [[ -z ${NEED_KDE} ]]; then
164 if [[ -n ${KDEBASE} ]]; then
165 NEED_KDE="latest"
166 else
167 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
168 fi
169fi
170export NEED_KDE
171
172case ${NEED_KDE} in
173 latest)
174 # Should only be used by 'kde-base'-ebuilds
175 if [[ "${KDEBASE}" == "kde-base" ]]; then
176 case ${PV} in
177 4.1*| 4.0.9* | 4.0.8*)
178 _kdedir="4.1"
179 _pv="-${PV}:4.1" ;;
180 4.0*)
181 _kdedir="4.0"
182 _pv="-${PV}:kde-4" ;;
183 3.9*)
184 _kdedir="3.9"
185 _pv="-${PV}:kde-4" ;;
186 *) 358 *) ;;
187 die "NEED_KDE=latest not supported for PV=${PV}" ;;
188 esac
189 _operator=">="
190 else
191 case ${PV} in
192 4.1 | 4.0.9* | 4.0.8*) _kdedir="4.1" ;;
193 4.0*) _kdedir="4.0" ;;
194 3.9*) _kdedir="3.9" ;;
195 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
196 esac 359 esac
197 fi 360 fi
198 ;; 361 fi
362fi
199 363
200 # NEED_KDE=":${SLOT}" 364kdedepend="
201 :kde-svn) 365 dev-util/automoc
202 _kdedir="svn" 366 dev-util/pkgconfig
203 _pv="-${NEED_KDE}" 367 !aqua? (
204 export NEED_KDE="svn" 368 >=x11-libs/libXtst-1.1.0
205 ;; 369 x11-proto/xf86vidmodeproto
206 :4.1)
207 _kdedir="4.1"
208 _pv="${NEED_KDE}"
209 ;;
210 :kde-4)
211 _kdedir="4.0"
212 _pv="${NEED_KDE}"
213 ;;
214
215 # NEED_KDE="${PV}:${SLOT}"
216 *:kde-svn)
217 _kdedir="svn"
218 _operator=">="
219 _pv="-${NEED_KDE}"
220 export NEED_KDE="svn"
221 ;;
222 *:4.1)
223 _kdedir="4.1"
224 _operator=">="
225 _pv="-${NEED_KDE}"
226 ;;
227 *:kde-4)
228 _kdedir="4.0"
229 _operator=">="
230 _pv="-${NEED_KDE}"
231 ;;
232
233 # NEED_KDE="${PV}"
234 scm|svn|9999*)
235 _kdedir="svn"
236 _operator=">="
237 _pv="-${NEED_KDE}:kde-svn"
238 export NEED_KDE="svn"
239 ;;
240 4.1 | 4.0.9* | 4.0.8*)
241 _kdedir="4.1"
242 _operator=">="
243 _pv="-${NEED_KDE}:4.1"
244 ;;
245 4.0* | 4)
246 _kdedir="4.0"
247 _operator=">="
248 _pv="-${NEED_KDE}:kde-4"
249 ;;
250 3.9*)
251 _kdedir="3.9"
252 _operator=">="
253 _pv="-${NEED_KDE}:kde-4"
254 ;;
255
256 # The ebuild handles dependencies, KDEDIR, SLOT.
257 none)
258 :
259 ;;
260
261 *) 370 )
262 die "NEED_KDE=${NEED_KDE} currently not supported." 371"
263 ;;
264esac
265 372
266if [[ ${NEED_KDE} != none ]]; then 373kderdepend=""
267 374
268 #Set the SLOT 375# all packages needs oxygen icons for basic iconset
376if [[ ${PN} != oxygen-icons ]]; then
377 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
378fi
379
380# add a dependency over kde-l10n if EAPI4 or better is around
381if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
382 for _lingua in ${KDE_LINGUAS}; do
383 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
384 # but only for selected ones.
385 # this can't be done on one line because if user doesn't use any localisation
386 # then he is probably not interested in kde-l10n at all.
387 kderdepend+="
388 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)?") )
389 "
390 done
391 unset _lingua
392fi
393
394kdehandbookdepend="
395 app-text/docbook-xml-dtd:4.2
396 app-text/docbook-xsl-stylesheets
397"
398kdehandbookrdepend="
399 $(add_kdebase_dep kdelibs 'handbook')
400"
401case ${KDE_HANDBOOK} in
402 always)
403 kdedepend+=" ${kdehandbookdepend}"
404 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
405 ;;
406 optional)
407 IUSE+=" +handbook"
408 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
409 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
410 ;;
411 *) ;;
412esac
413unset kdehandbookdepend kdehandbookrdepend
414
415case ${KDE_REQUIRED} in
416 always)
417 IUSE+=" aqua"
418 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
419 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
420 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
421 ;;
422 optional)
423 IUSE+=" aqua kde"
424 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
425 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
426 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
427 ;;
428 *) ;;
429esac
430
431unset kdecommondepend kdedepend kderdepend
432
433debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
434debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
435debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
436
437# Accumulate dependencies set by this eclass
438DEPEND+=" ${COMMONDEPEND}"
439RDEPEND+=" ${COMMONDEPEND}"
440unset COMMONDEPEND
441
442# Add experimental kdeenablefinal, masked by default
443IUSE+=" kdeenablefinal"
444
445# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
446# koffice ebuild, the URI should be set in the ebuild itself
447_calculate_src_uri() {
448 debug-print-function ${FUNCNAME} "$@"
449
450 local _kmname _kmname_pv
451
452 # we calculate URI only for known KDEBASE modules
453 [[ -n ${KDEBASE} ]] || return
454
455 # calculate tarball module name
269 if [[ -n ${KDEBASE} ]]; then 456 if [[ -n ${KMNAME} ]]; then
270 if [[ ${NEED_KDE} = svn ]]; then 457 # fixup kdebase-apps name
271 SLOT="kde-svn" 458 case ${KMNAME} in
459 kdebase-apps)
460 _kmname="kdebase" ;;
461 *)
462 _kmname="${KMNAME}" ;;
463 esac
272 else 464 else
465 _kmname=${PN}
466 fi
467 _kmname_pv="${_kmname}-${PV}"
468 case ${KDEBASE} in
469 kde-base)
273 case ${PV} in 470 case ${PV} in
274 4.1* | 4.0.9* | 4.0.8*) SLOT="4.1" ;; 471 4.[456].8[05] | 4.[456].9[023568])
275 *) SLOT="kde-4" ;; 472 # Unstable KDE SC releases
473 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
474 # KDEPIM IS SPECIAL
475 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
476 ;;
477 4.4.[6789] | 4.4.1?*)
478 # Stable kdepim releases
479 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
480 ;;
481 *)
482 # Stable KDE SC releases
483 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
484 ;;
276 esac 485 esac
277 fi 486 ;;
278 fi 487 koffice)
279
280 # Block install of other SLOTS unless kdeprefix
281 case "${EAPI}" in 488 case ${PV} in
282 2 | 2_pre3 | 2_pre2 | 2_pre1) 489 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
283 for KDE_SLOT in ${KDE_SLOTS[@]}; do 490 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
284 # block non kdeprefix ${PN} on other slots 491 esac
285 if [[ ${SLOT} != ${KDE_SLOT} ]]; then 492 ;;
286 DEPEND="${DEPEND} 493 kdevelop)
287 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )" 494 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
288 RDEPEND="${RDEPEND}
289 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )"
290 fi
291 done
292 ;; 495 ;;
293 esac 496 esac
497}
294 498
295 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 499_calculate_live_repo() {
296 if [[ ${PN} != "kdelibs" ]]; then 500 debug-print-function ${FUNCNAME} "$@"
501
502 SRC_URI=""
503 case ${KDE_SCM} in
504 svn)
505 # Determine branch URL based on live type
506 local branch_prefix
297 case "${EAPI}" in 507 case ${PV} in
298 2 | 2_pre3 | 2_pre2 | 2_pre1) 508 9999*)
299 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 509 # trunk
300 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 510 branch_prefix="trunk/KDE"
511 ;;
512 *)
513 # branch
514 branch_prefix="branches/KDE/${SLOT}"
515 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
516 # @DESCRIPTION
517 # Suffix appended to ESVN_PROJECT depending on fetched branch.
518 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
519 ESVN_PROJECT_SUFFIX="-${PV}"
520 ;;
521 esac
522 # @ECLASS-VARIABLE: ESVN_MIRROR
523 # @DESCRIPTION:
524 # This variable allows easy overriding of default kde mirror service
525 # (anonsvn) with anything else you might want to use.
526 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
527 # Split ebuild, or extragear stuff
528 if [[ -n ${KMNAME} ]]; then
529 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
530 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
531 KMMODULE="${PN}"
532 fi
533 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
534 case ${KMNAME} in
535 kdebase-*)
536 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
537 ;;
538 kdelibs-*)
539 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
540 ;;
541 kdereview*)
542 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
543 ;;
544 kdesupport)
545 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
546 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
547 ;;
548 kde*)
549 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
550 ;;
551 extragear*|playground*)
552 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
553 # build packages from same svn location.
554 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
555 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
556 ;;
557 koffice)
558 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
559 ;;
560 *)
561 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
562 ;;
563 esac
564 else
565 # kdelibs, kdepimlibs
566 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
567 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
568 fi
569 # @ECLASS-VARIABLE: ESVN_UP_FREQ
570 # @DESCRIPTION:
571 # This variable is used for specifying the timeout between svn synces
572 # for kde-base and koffice modules. Does not affect misc apps.
573 # Default value is 1 hour.
574 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
575 ;;
576 git)
577 local _kmname
578 # @ECLASS-VARIABLE: EGIT_MIRROR
579 # @DESCRIPTION:
580 # This variable allows easy overriding of default kde mirror service
581 # (anongit) with anything else you might want to use.
582 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
583
584 # @ECLASS-VARIABLE: EGIT_REPONAME
585 # @DESCRIPTION:
586 # This variable allows overriding of default repository
587 # name. Specify only if this differ from PN and KMNAME.
588 if [[ -n ${EGIT_REPONAME} ]]; then
589 # the repository and kmname different
590 _kmname=${EGIT_REPONAME}
591 elif [[ -n ${KMNAME} ]]; then
592 _kmname=${KMNAME}
593 else
594 _kmname=${PN}
595 fi
596
597 # default branching
598 case ${PV} in
599 9999*) ;;
600 *)
601 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
602 case ${_kmname} in
603 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs)
604 EGIT_BRANCH="${SLOT}"
605 ;;
606 *) EGIT_BRANCH="KDE/${SLOT}" ;;
607 esac
608 ;;
609 esac
610
611 case $_kmname in
612 kdepim|kdepim-runtime)
613 case ${PV} in
614 # kdepim still did not branch
615 4.6.9999)
616 EGIT_BRANCH="master"
617 ;;
618 esac
619 ;;
620 esac
621 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
622 EGIT_PROJECT="${_kmname}"
623
624 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
625 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
626 ;;
627 esac
628}
629
630case ${BUILD_TYPE} in
631 live) _calculate_live_repo ;;
632 *) _calculate_src_uri ;;
633esac
634
635debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
636
637# @ECLASS-VARIABLE: PREFIX
638# @DESCRIPTION:
639# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
640# kde-base packages go into KDE4 installation directory (KDEDIR) by default.
641# No matter the PREFIX, package will be built against KDE installed in KDEDIR.
642
643# @FUNCTION: kde4-base_pkg_setup
644# @DESCRIPTION:
645# Do the basic kdeprefix KDEDIR settings and determine with which kde should
646# optional applications link
647kde4-base_pkg_setup() {
648 debug-print-function ${FUNCNAME} "$@"
649
650 # QA ebuilds
651 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
652
653 # Don't set KDEHOME during compilation, it will cause access violations
654 unset KDEHOME
655
656 if [[ ${KDEBASE} = kde-base ]]; then
657 if use kdeprefix; then
658 KDEDIR=/usr/kde/${SLOT}
659 else
660 KDEDIR=/usr
661 fi
662 : ${PREFIX:=${KDEDIR}}
663 else
664 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
665 KDEDIR=
666 local kde_minimal_met
667 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
668 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
669 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
670 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
671 KDEDIR=/usr/kde/${slot}
672 else
673 KDEDIR=/usr
674 fi
675 break;
676 fi
677 done
678 unset slot
679
680 # Bail out if kdelibs required but not found
681 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
682 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
683 else
684 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
685 fi
686
687 : ${PREFIX:=/usr}
688 fi
689 EKDEDIR=${EPREFIX}${KDEDIR}
690
691 # Point pkg-config path to KDE *.pc files
692 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
693 # Point to correct QT plugins path
694 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/"
695
696 # Fix XDG collision with sandbox
697 export XDG_CONFIG_HOME="${T}"
698}
699
700# @FUNCTION: kde4-base_src_unpack
701# @DESCRIPTION:
702# This function unpacks the source tarballs for KDE4 applications.
703kde4-base_src_unpack() {
704 debug-print-function ${FUNCNAME} "$@"
705
706 if [[ ${BUILD_TYPE} = live ]]; then
707 case ${KDE_SCM} in
708 svn)
709 migrate_store_dir
710 subversion_src_unpack
301 ;; 711 ;;
302 *) 712 git)
303 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}" 713 git_src_unpack
304 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}"
305 ;; 714 ;;
306 esac 715 esac
307 if [[ ${PN} != "kdepimlibs" ]]; then
308 case "${EAPI}" in
309 2 | 2_pre3 | 2_pre2 | 2_pre1)
310 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
311 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
312 ;;
313 *)
314 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
315 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
316 esac
317 fi
318 fi
319
320 unset _operator _pv
321fi
322
323# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
324# koffice ebuild, the URI should be set in the ebuild itself
325if [[ -n ${KDEBASE} ]]; then
326 if [[ -n ${KMNAME} ]]; then
327 _kmname=${KMNAME}
328 else 716 else
329 _kmname=${PN} 717 unpack ${A}
330 fi
331 _kmname_pv="${_kmname}-${PV}"
332 if [[ ${NEED_KDE} != "svn" ]]; then
333 case ${KDEBASE} in
334 kde-base)
335 case ${PV} in
336 4.0.9* | 4.0.8*)
337 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
338 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";;
339 esac
340 ;;
341 koffice)
342 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
343 ;;
344 esac
345 fi
346 unset _kmname _kmname_pv
347fi
348
349debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
350
351# @ECLASS-VARIABLE: PREFIX
352# @DESCRIPTION:
353# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
354# Applications installed by the other ebuilds go into /usr/ by default, this value
355# can be superseded by defining PREFIX before inheriting kde4-base.
356# This value is set on pkg_setup
357PREFIX=""
358
359debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - NEED_KDE ${NEED_KDE}"
360
361# @FUNCTION: kde4-base_pkg_setup
362# @DESCRIPTION:
363# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
364# kde4-functions_check_use from kde4-functions.eclass to print appropriate
365# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
366# $KDE4_BUILT_WITH_USE_CHECK are missing.
367kde4-base_pkg_setup() {
368 debug-print-function $FUNCNAME "$@"
369
370 # Don't set KDEHOME during compile, it will cause access violations
371 unset KDEHOME
372
373 if [[ ${NEED_KDE} != none ]]; then
374
375 # Set PREFIX
376 case "${EAPI}" in
377 2 | 2_pre3 | 2_pre2 | 2_pre1)
378 if use kdeprefix; then
379 KDEDIR="/usr/kde/${_kdedir}"
380 KDEDIRS="/usr:/usr/local:${KDEDIR}"
381 else
382 KDEDIR="/usr"
383 KDEDIRS="/usr:/usr/local"
384 fi
385 ;;
386 *)
387 KDEDIR="/usr"
388 KDEDIRS="/usr:/usr/local"
389 ;;
390 esac
391 fi
392
393 # Set the prefix based on KDEDIR
394 # Make it a consequence of kdeprefix
395 PREFIX=${KDEDIR}
396
397 unset _kdedir
398
399 case "${EAPI}" in
400 2 | 2_pre3 | 2_pre2 | 2_pre1)
401 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK[@]} ]] && \
402 die "built_with_use illegal in this EAPI!"
403 ;;
404 *)
405 # Make KDE4_BUILT_WITH_USE_CHECK an array if it isn't already
406 local line kde4_built_with_use_check=()
407 if [[ -n ${KDE4_BUILT_WITH_USE_CHECK[@]} && $(declare -p KDE4_BUILT_WITH_USE_CHECK) != 'declare -a '* ]]; then
408 while read line; do
409 [[ -z ${line} ]] && continue
410 kde4_built_with_use_check+=("${line}")
411 done <<< "${KDE4_BUILT_WITH_USE_CHECK}"
412 KDE4_BUILT_WITH_USE_CHECK=("${kde4_built_with_use_check[@]}")
413 fi 718 fi
414
415 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
416 if has_version '<x11-libs/qt-4.4_alpha:4'; then
417 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
418 else
419 KDE4_BUILT_WITH_USE_CHECK=("${KDE4_BUILT_WITH_USE_CHECK[@]}"
420 "x11-libs/qt-core qt3support ssl"
421 "x11-libs/qt-gui accessibility dbus"
422 "x11-libs/qt-qt3support accessibility")
423 fi
424
425 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
426 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
427 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
428 fi
429 fi
430 kde4-functions_check_use
431 ;;
432 esac
433} 719}
434 720
435# @FUNCTION: kde4-base_apply_patches
436# @DESCRIPTION:
437# This function applies patches.
438#
439# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
440# directory, provided they follow this format:
441# @CODE
442# - Monolithic ebuilds, (from kde-base)
443# - $CATEGORY=kde-base:
444# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
445# - $CATEGORY=!kde-base:
446# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
447# - Split ebuilds:
448# - $CATEGORY=kde-base:
449# Apply ${PN}-${SLOT}-*{diff,patch}
450# - $CATEGORY!=kde-base:
451# Apply ${PN}-${PV}-*{diff,patch}
452# @CODE
453#
454# If ${PATCHES} is non-zero all patches in it get applied. If there is more
455# than one patch please make ${PATCHES} an array for proper quoting.
456kde4-base_apply_patches() {
457 local _patchdir _packages _p _f
458 _patchdir="${WORKDIR}/patches/"
459 if [[ -d "${_patchdir}" ]]; then
460 if is-parent-package ${CATEGORY}/${PN} ; then
461 _packages="$(get-child-packages ${CATEGORY}/${PN})"
462 _packages="${_packages//${CATEGORY}\//} ${PN}"
463 else
464 _packages="${PN}"
465 fi
466 if [[ $(declare -p PATCHES) != 'declare -a '* ]]; then
467 die "PATCHES needs to be an array!"
468 fi
469 for _p in ${_packages}; do
470 for _f in "${_patchdir}"/${_p}-${PV}-*{diff,patch}; do
471 [[ -e ${_f} ]] && PATCHES+=("${_f}")
472 done
473 if [[ -n "${KDEBASE}" ]]; then
474 for _f in "${_patchdir}"/${_p}-${SLOT}-*{diff,patch}; do
475 [[ -e ${_f} ]] && PATCHES+=("${_f}")
476 done
477 fi
478 done
479 fi
480 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
481}
482
483# @FUNCTION: kde4-base_src_unpack 721# @FUNCTION: kde4-base_src_prepare
484# @DESCRIPTION: 722# @DESCRIPTION:
485# This function unpacks the source tarballs for KDE4 applications. 723# General pre-configure and pre-compile function for KDE4 applications.
486#
487# If no argument is passed to this function, then standard src_unpack is
488# executed. Otherwise options are passed to base_src_unpack.
489#
490# In addition it calls kde4-base_apply_patches when no arguments are passed to
491# this function.
492#
493# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 724# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
725# enable_selected_linguas() and enable_selected_doc_linguas()
494# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 726# in kde4-functions.eclass(5) for further details.
495kde4-base_src_unpack() { 727kde4-base_src_prepare() {
496 debug-print-function $FUNCNAME "$@" 728 debug-print-function ${FUNCNAME} "$@"
497 729
498 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 730 # enable handbook and linguas only when not using live ebuild
499
500 if [[ -z $* ]]; then
501 # Unpack first and deal with KDE patches after examing possible patch sets.
502 # To be picked up, patches need to conform to the guidelines stated before.
503 # Monolithic ebuilds will use the split ebuild patches.
504 [[ -d "${KDE_S}" ]] || unpack ${A}
505 base_src_unpack $*
506 else
507 # Call base_src_unpack, which unpacks and patches
508 # step by step transparently as defined in the ebuild.
509 base_src_unpack $*
510 fi
511
512 # Updated cmake dir
513 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
514 ebegin "Updating cmake/ directory..."
515 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
516 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
517 eend 0
518 fi
519 731
520 # Only enable selected languages, used for KDE extragear apps. 732 # Only enable selected languages, used for KDE extragear apps.
521 if [[ -n ${KDE_LINGUAS} ]]; then 733 if [[ -n ${KDE_LINGUAS} ]]; then
522 enable_selected_linguas 734 enable_selected_linguas
523 fi 735 fi
736
737 # Enable/disable handbooks for kde4-base packages
738 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
739 # kdelibs inherits kde4-base but handle installing the handbook itself
740 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then
741 if [[ ${KDEBASE} == kde-base ]]; then
742 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
743 # documentation in kde4-functions
744 : ${KDE_DOC_DIRS:=doc}
745 local dir
746 for dir in ${KDE_DOC_DIRS}; do
747 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
748 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
749 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
750 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
751 -i CMakeLists.txt || die "failed to comment out handbook"
752 done
753 fi
754 else
755 enable_selected_doc_linguas
756 fi
757 fi
758
759 # SCM bootstrap
760 if [[ ${BUILD_TYPE} = live ]]; then
761 case ${KDE_SCM} in
762 svn) subversion_src_prepare ;;
763 esac
764 fi
765
766 # Apply patches
767 base_src_prepare
768
769 # Save library dependencies
770 if [[ -n ${KMSAVELIBS} ]] ; then
771 save_library_dependencies
772 fi
773
774 # Inject library dependencies
775 if [[ -n ${KMLOADLIBS} ]] ; then
776 load_library_dependencies
777 fi
778
779 # Replace KDE4Workspace library targets
780 find "${S}" -name CMakeLists.txt \
781 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
782 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
783 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
784 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
785 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
786 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
787 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
788 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
789 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
790 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
791 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
792 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
793 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
794 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
795 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
796 || die 'failed to replace KDE4Workspace library targets'
797
798 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
799 if [[ -z ${KDEBASE} ]]; then
800 find "${S}" -name "*.docbook" \
801 -exec sed -i -r \
802 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
803 || die 'failed to fix DocBook variant version'
804 fi
805}
806
807# @FUNCTION: kde4-base_src_configure
808# @DESCRIPTION:
809# Function for configuring the build of KDE4 applications.
810kde4-base_src_configure() {
811 debug-print-function ${FUNCNAME} "$@"
812
813 # Build tests in src_test only, where we override this value
814 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
815
816 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
817 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
818 fi
819
820 if has debug ${IUSE//+} && use debug; then
821 # Set "real" debug mode
822 CMAKE_BUILD_TYPE="Debugfull"
823 else
824 # Handle common release builds
825 append-cppflags -DQT_NO_DEBUG
826 fi
827
828 # Set distribution name
829 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
830
831 # Here we set the install prefix
832 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
833
834 # Use colors
835 QTEST_COLORED=1
836
837 # Shadow existing /usr installations
838 unset KDEDIRS
839
840 # Handle kdeprefix-ed KDE
841 if [[ ${KDEDIR} != /usr ]]; then
842 # Override some environment variables - only when kdeprefix is different,
843 # to not break ccache/distcc
844 PATH="${EKDEDIR}/bin:${PATH}"
845
846 # Append library search path
847 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
848
849 # Append full RPATH
850 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
851
852 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
853 # when more are present
854 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
855 fi
856
857 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
858 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4)
859 #kde-config -path data unavailable when cross-compiling
860 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
861
862 # Handle kdeprefix in application itself
863 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
864 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
865 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
866 fi
867
868 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
869 mycmakeargs=(${mycmakeargs})
870 fi
871
872 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
873
874 cmake-utils_src_configure
524} 875}
525 876
526# @FUNCTION: kde4-base_src_compile 877# @FUNCTION: kde4-base_src_compile
527# @DESCRIPTION: 878# @DESCRIPTION:
528# General function for compiling KDE4 applications. 879# General function for compiling KDE4 applications.
529kde4-base_src_compile() { 880kde4-base_src_compile() {
530 debug-print-function ${FUNCNAME} "$@" 881 debug-print-function ${FUNCNAME} "$@"
531 case "${EAPI}" in
532 2)
533 ;;
534 *)
535 kde4-base_src_configure
536 ;;
537 esac
538 if [[ -d ${WORKDIR}/${PN}_build ]]; then
539 pushd "${WORKDIR}"/${PN}_build > /dev/null
540 fi
541 [ -e [Mm]akefile ] && kde4-base_src_make
542}
543 882
544# @FUNCTION: kde4-base_src_configure
545# @DESCRIPTION:
546# Function for configuring the build of KDE4 applications.
547kde4-base_src_configure() {
548 debug-print-function ${FUNCNAME} "$@"
549
550 # Final flag handling
551 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
552 echo "Activating enable-final flag"
553 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
554 fi
555
556 # Enable generation of HTML handbook
557 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
558 echo "Enabling building of HTML handbook"
559 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
560 fi
561
562 # Build tests in src_test only, where we override this value
563 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
564
565 # Set distribution name
566 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
567
568 # runpath linking
569 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
570
571 # Here we set the install prefix
572 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
573
574 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
575 [[ "${PREFIX}" == "/usr" ]] && mycmakeargs="${mycmakeargs} -DSYSCONF_INSTALL_DIR=/etc"
576
577 # Set environment
578 QTEST_COLORED=1
579 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
580
581 # hardcode path to *.cmake KDE files
582 PKG_CONFIG_PATH="${PKG_CONFIG_PATH:+${PKG_CONFIG_PATH}:}${KDEDIR}/$(get_libdir)/pkgconfig"
583
584 [ -e CMakeLists.txt ] && cmake-utils_src_configureout
585}
586
587# @FUNCTION: kde4-base_src_make
588# @DESCRIPTION:
589# Function for building KDE4 applications.
590# Options are passed to cmake-utils_src_make.
591kde4-base_src_make() {
592 debug-print-function ${FUNCNAME} "$@"
593
594 cmake-utils_src_make "$@" 883 cmake-utils_src_compile "$@"
595} 884}
596 885
597# @FUNCTION: kde4-base_src_test 886# @FUNCTION: kde4-base_src_test
598# @DESCRIPTION: 887# @DESCRIPTION:
599# Function for testing KDE4 applications. 888# Function for testing KDE4 applications.
600kde4-base_src_test() { 889kde4-base_src_test() {
601 debug-print-function ${FUNCNAME} "$@" 890 debug-print-function ${FUNCNAME} "$@"
602 891
603 # Override this value, set in kde4-base_src_configure() 892 # Override this value, set in kde4-base_src_configure()
604 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 893 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
605 cmake-utils_src_compile 894 cmake-utils_src_configure
895 kde4-base_src_compile
606 896
897 # When run as normal user during ebuild development with the ebuild command, the
898 # kde tests tend to access the session DBUS. This however is not possible in a real
899 # emerge or on the tinderbox.
900 # > make sure it does not happen, so bad tests can be recognized and disabled
901 unset DBUS_SESSION_BUS_ADDRESS
902
903 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
904 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
905 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
906 # surprise- we are already INSIDE virtualmake!!!
907 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
908 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
909 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
910 debug-print " kde4-base.eclass docs for details... Applying workaround."
911 cmake-utils_src_test
912 else
913 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
914 fi
915 else
607 cmake-utils_src_test 916 cmake-utils_src_test
917 fi
608} 918}
609 919
610# @FUNCTION: kde4-base_src_install 920# @FUNCTION: kde4-base_src_install
611# @DESCRIPTION: 921# @DESCRIPTION:
612# Function for installing KDE4 applications. 922# Function for installing KDE4 applications.
613kde4-base_src_install() { 923kde4-base_src_install() {
614 debug-print-function ${FUNCNAME} "$@" 924 debug-print-function ${FUNCNAME} "$@"
615 925
616 kde4-base_src_make_doc 926 if [[ -n ${KMSAVELIBS} ]] ; then
617 if [[ -d ${WORKDIR}/${PN}_build ]]; then 927 install_library_dependencies
618 pushd "${WORKDIR}"/${PN}_build > /dev/null
619 fi 928 fi
620 [ -e [Mm]akefile ] && cmake-utils_src_install
621}
622 929
623# @FUNCTION: kde4-base_src_make_doc
624# @DESCRIPTION:
625# Function for installing the documentation of KDE4 applications. 930 # Install common documentation of KDE4 applications
626kde4-base_src_make_doc() {
627 debug-print-function ${FUNCNAME} "$@"
628
629 local doc 931 local doc
630 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 932 if ! has kde4-meta ${INHERITED}; then
631 [[ -s $doc ]] && dodoc ${doc} 933 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
632 done 934 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
633
634 if [[ -z ${KMNAME} ]]; then
635 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
636 if [[ -s $doc ]]; then
637 local doc_complete=${doc}
638 doc="${doc#*/}"
639 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
640 fi
641 done 935 done
936 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
937 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
938 done
642 fi 939 fi
643 940
644 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then 941 cmake-utils_src_install
645 # work around bug #97196 942
646 dodir /usr/share/doc/kde && \ 943 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
647 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \ 944 # because then khelpcenter can't find the docs
648 die "Failed to move docs to kde/ failed." 945 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
649 fi 946 docompress -x ${PREFIX}/share/doc/HTML
947}
948
949# @FUNCTION: kde4-base_pkg_preinst
950# @DESCRIPTION:
951# Function storing icon caches
952kde4-base_pkg_preinst() {
953 debug-print-function ${FUNCNAME} "$@"
954
955 gnome2_icon_savelist
650} 956}
651 957
652# @FUNCTION: kde4-base_pkg_postinst 958# @FUNCTION: kde4-base_pkg_postinst
653# @DESCRIPTION: 959# @DESCRIPTION:
654# Function to rebuild the KDE System Configuration Cache after an application has been installed. 960# Function to rebuild the KDE System Configuration Cache after an application has been installed.
655kde4-base_pkg_postinst() { 961kde4-base_pkg_postinst() {
962 debug-print-function ${FUNCNAME} "$@"
963
964 gnome2_icon_cache_update
965 fdo-mime_desktop_database_update
966 fdo-mime_mime_database_update
656 buildsycoca 967 buildsycoca
968
969 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
970 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
971 echo
972 ewarn "WARNING! you have kdeenable final useflag enabled."
973 ewarn "This useflag needs to be enabled on ALL kde using packages and"
974 ewarn "is known to cause issues."
975 ewarn "You are using this setup at your own risk and the kde team does not"
976 ewarn "take responsibilities for dead kittens."
977 echo
978 fi
979 if [[ ${BUILD_TYPE} = live ]]; then
980 echo
981 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
982 einfo "Use it at your own risk."
983 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
984 echo
985 elif [[ ${BUILD_TYPE} != live ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
986 # warning about kdeprefix for non-live users
987 echo
988 ewarn "WARNING! You have the kdeprefix useflag enabled."
989 ewarn "This setting is strongly discouraged and might lead to potential trouble"
990 ewarn "with KDE update strategies."
991 ewarn "You are using this setup at your own risk and the kde team does not"
992 ewarn "take responsibilities for dead kittens."
993 echo
994 fi
995 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
996 if [[ ${KDEBASE} != kde-base ]] && \
997 ! has_version 'kde-base/kdebase-runtime-meta' && \
998 ! has_version 'kde-base/kdebase-startkde'; then
999 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
1000 echo
1001 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
1002 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
1003 ewarn "With this setting you are unsupported by KDE team."
1004 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
1005 fi
1006 fi
1007 fi
657} 1008}
658 1009
659# @FUNCTION: kde4-base_pkg_postrm 1010# @FUNCTION: kde4-base_pkg_postrm
660# @DESCRIPTION: 1011# @DESCRIPTION:
661# Function to rebuild the KDE System Configuration Cache after an application has been removed. 1012# Function to rebuild the KDE System Configuration Cache after an application has been removed.
662kde4-base_pkg_postrm() { 1013kde4-base_pkg_postrm() {
1014 debug-print-function ${FUNCNAME} "$@"
1015
1016 gnome2_icon_cache_update
1017 fdo-mime_desktop_database_update
1018 fdo-mime_mime_database_update
663 buildsycoca 1019 buildsycoca
664} 1020}

Legend:
Removed from v.1.17  
changed lines
  Added in v.1.90

  ViewVC Help
Powered by ViewVC 1.1.20